(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun init_f_~k_ref~2.base () Int)
(declare-fun honda_f_~k_ref~2.base () Int)
(declare-fun ray_f_~k_ref~2.base () Int)
(declare-fun init_f_~l_ref~2.base () Int)
(declare-fun honda_f_~l_ref~2.base () Int)
(declare-fun ray_f_~l_ref~2.base () Int)
(declare-fun |init_f_#t~post15| () Int)
(declare-fun |honda_f_#t~post15| () Int)
(declare-fun |ray_f_#t~post15| () Int)
(declare-fun |init_f_#t~malloc0.offset| () Int)
(declare-fun |honda_f_#t~malloc0.offset| () Int)
(declare-fun |ray_f_#t~malloc0.offset| () Int)
(declare-fun init_f_~i~2.offset () Int)
(declare-fun honda_f_~i~2.offset () Int)
(declare-fun ray_f_~i~2.offset () Int)
(declare-fun |init_f_#t~malloc0.base| () Int)
(declare-fun |honda_f_#t~malloc0.base| () Int)
(declare-fun |ray_f_#t~malloc0.base| () Int)
(declare-fun init_f_~j~2.base () Int)
(declare-fun honda_f_~j~2.base () Int)
(declare-fun ray_f_~j~2.base () Int)
(declare-fun |init_f_#in~l| () Int)
(declare-fun |honda_f_#in~l| () Int)
(declare-fun |ray_f_#in~l| () Int)
(declare-fun |init_f_#t~mem13| () Int)
(declare-fun |honda_f_#t~mem13| () Int)
(declare-fun |ray_f_#t~mem13| () Int)
(declare-fun |init_f_#t~malloc3.offset| () Int)
(declare-fun |honda_f_#t~malloc3.offset| () Int)
(declare-fun |ray_f_#t~malloc3.offset| () Int)
(declare-fun |init_f_#t~malloc3.base| () Int)
(declare-fun |honda_f_#t~malloc3.base| () Int)
(declare-fun |ray_f_#t~malloc3.base| () Int)
(declare-fun init_f_~k () Int)
(declare-fun honda_f_~k () Int)
(declare-fun ray_f_~k () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |init_f_#t~malloc2.offset| () Int)
(declare-fun |honda_f_#t~malloc2.offset| () Int)
(declare-fun |ray_f_#t~malloc2.offset| () Int)
(declare-fun init_f_~l () Int)
(declare-fun honda_f_~l () Int)
(declare-fun ray_f_~l () Int)
(declare-fun |init_f_#t~malloc2.base| () Int)
(declare-fun |honda_f_#t~malloc2.base| () Int)
(declare-fun |ray_f_#t~malloc2.base| () Int)
(declare-fun |init_f_#in~k| () Int)
(declare-fun |honda_f_#in~k| () Int)
(declare-fun |ray_f_#in~k| () Int)
(declare-fun init_f_~k_ref~2.offset () Int)
(declare-fun honda_f_~k_ref~2.offset () Int)
(declare-fun ray_f_~k_ref~2.offset () Int)
(declare-fun init_f_~l_ref~2.offset () Int)
(declare-fun honda_f_~l_ref~2.offset () Int)
(declare-fun ray_f_~l_ref~2.offset () Int)
(declare-fun init_f_~j~2.offset () Int)
(declare-fun honda_f_~j~2.offset () Int)
(declare-fun ray_f_~j~2.offset () Int)
(declare-fun |init_f_#t~mem14| () Int)
(declare-fun |honda_f_#t~mem14| () Int)
(declare-fun |ray_f_#t~mem14| () Int)
(declare-fun |init_f_#t~mem16| () Int)
(declare-fun |honda_f_#t~mem16| () Int)
(declare-fun |ray_f_#t~mem16| () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun |init_f_#t~malloc1.base| () Int)
(declare-fun |honda_f_#t~malloc1.base| () Int)
(declare-fun |ray_f_#t~malloc1.base| () Int)
(declare-fun |init_f_#t~malloc1.offset| () Int)
(declare-fun |honda_f_#t~malloc1.offset| () Int)
(declare-fun |ray_f_#t~malloc1.offset| () Int)
(declare-fun |init_f_#t~mem9| () Int)
(declare-fun |honda_f_#t~mem9| () Int)
(declare-fun |ray_f_#t~mem9| () Int)
(declare-fun init_f_~i~2.base () Int)
(declare-fun honda_f_~i~2.base () Int)
(declare-fun ray_f_~i~2.base () Int)
(declare-fun |init_f_#t~mem8| () Int)
(declare-fun |honda_f_#t~mem8| () Int)
(declare-fun |ray_f_#t~mem8| () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun |honda_(select #length f_~j~2.base)| () Int)
(declare-fun |ray_(select #length f_~j~2.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| ()
  Int)
(declare-fun
  |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)| ()
  Int)
(declare-fun |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| () Int)
(declare-fun |honda_(select old(#length) f_~i~2.base)| () Int)
(declare-fun |ray_(select old(#length) f_~i~2.base)| () Int)
(declare-fun |honda_(ite (select #valid f_~i~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid f_~i~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| () Int)
(declare-fun |honda_(select old(#length) f_~l_ref~2.base)| () Int)
(declare-fun |ray_(select old(#length) f_~l_ref~2.base)| () Int)
(declare-fun |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
  () Int)
(declare-fun |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| ()
  Int)
(declare-fun |honda_(select #length f_~i~2.base)| () Int)
(declare-fun |ray_(select #length f_~i~2.base)| () Int)
(declare-fun |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| () Int)
(declare-fun |honda_(select #length f_~l_ref~2.base)| () Int)
(declare-fun |ray_(select #length f_~l_ref~2.base)| () Int)
(declare-fun |honda_(select #length f_~k_ref~2.base)| () Int)
(declare-fun |ray_(select #length f_~k_ref~2.base)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| () Int)
(declare-fun |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
  () Int)
(declare-fun |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| ()
  Int)
(declare-fun
  |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| () Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |honda_(select old(#length) f_~j~2.base)| () Int)
(declare-fun |ray_(select old(#length) f_~j~2.base)| () Int)
(declare-fun |honda_(select old(#length) f_~k_ref~2.base)| () Int)
(declare-fun |ray_(select old(#length) f_~k_ref~2.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
  () Int)
(declare-fun |honda_(ite (select #valid f_~j~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid f_~j~2.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
  () Int)
(declare-fun |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| () Int)
(declare-fun lambda () Int)
(declare-fun aux_6158 () Int)
(declare-fun aux_6159 () Int)
(declare-fun aux_6164 () Int)
(declare-fun aux_6165 () Int)
(declare-fun aux_6170 () Int)
(declare-fun aux_6171 () Int)
(declare-fun aux_6176 () Int)
(declare-fun aux_6177 () Int)
(declare-fun aux_6182 () Int)
(declare-fun aux_6183 () Int)
(declare-fun aux_6188 () Int)
(declare-fun aux_6189 () Int)
(declare-fun aux_6194 () Int)
(declare-fun aux_6195 () Int)
(declare-fun aux_6200 () Int)
(declare-fun aux_6201 () Int)
(declare-fun aux_6206 () Int)
(declare-fun aux_6207 () Int)
(declare-fun aux_6212 () Int)
(declare-fun aux_6213 () Int)
(declare-fun aux_6218 () Int)
(declare-fun aux_6219 () Int)
(declare-fun aux_6224 () Int)
(declare-fun aux_6225 () Int)
(assert
 (and
 (or
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base (- 1))
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_f_#t~post15| |honda_f_#t~post15|)
 (= |init_f_#t~mem13| |honda_f_#t~mem13|)
 (= |init_f_#t~mem14| |honda_f_#t~mem14|)
 (= |init_f_#t~mem16| |honda_f_#t~mem16|)
 (= |init_f_#t~mem9| |honda_f_#t~mem9|)
 (= |init_f_#t~mem8| |honda_f_#t~mem8|)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 1)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 1) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| (- 1))
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 1)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| (- 1)) 
 (* honda_f_~k_ref~2.offset 0) 
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 1)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 1)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 1) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base (- 1)) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| (- 1))
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 1) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 1) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l (- 1))
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| (- 1))
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| (- 1))
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 1)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 1)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 1)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| (- 1))
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 1)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset (- 1)) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset (- 1)) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 1) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base (- 1)) 
 (* |honda_f_#t~mem13| 0) 
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 1) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 1) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset (- 1))
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset (- 1)) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 1) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 1)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| (- 1)) 
 (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k 0) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 0) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length f_~j~2.base)| 0)
 (* |honda_(ite (select old(#valid) f_~j~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0)
 (* |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~i~2.base)| 0)
 (* |honda_f_#t~malloc0.offset| 0) 
 (* honda_f_~i~2.offset 0) 
 (* honda_f_~j~2.base 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(ite (select #valid f_~i~2.base) 1 0)| 0)
 (* |honda_f_#t~malloc3.offset| 0) 
 (* honda_f_~k (- 1)) (* honda_f_~l 0)
 (* |honda_(ite (select #valid f_~k_ref~2.base) 1 0)| 0)
 (* |honda_(select old(#length) f_~l_ref~2.base)| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select #length f_~i~2.base)| 0)
 (* |honda_(ite (select #valid f_~l_ref~2.base) 1 0)| 0)
 (* honda_f_~j~2.offset 0) 
 (* |honda_(select #length f_~l_ref~2.base)| 0)
 (* |honda_(select #length f_~k_ref~2.base)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~malloc1.offset| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_f_~k_ref~2.base 0) 
 (* honda_f_~l_ref~2.base 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0)
 (* |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_f_#t~malloc0.base| 0) 
 (* |honda_f_#in~l| 0) (* |honda_f_#t~malloc3.base| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select old(#length) f_~j~2.base)| 0)
 (* |honda_f_#t~malloc2.offset| 0)
 (* |honda_(select old(#length) f_~k_ref~2.base)| 0)
 (* |honda_f_#t~malloc2.base| 0) 
 (* |honda_f_#in~k| 1) (* honda_f_~k_ref~2.offset 0)
 (* honda_f_~l_ref~2.offset 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0)
 (* |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 0) (* |honda_f_#t~malloc1.base| 0) 
 (* |honda_f_#t~mem9| 0) (* honda_f_~i~2.base 0)
 (* |honda_(ite (select #valid f_~j~2.base) 1 0)| 0) 
 (* |honda_f_#t~mem8| 0)
 (*
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_(ite (select old(#valid) f_~i~2.base) 1 0)| 0)
 (* init_f_~k_ref~2.base 0) 
 (* init_f_~l_ref~2.base 0) 
 (* |init_f_#t~malloc0.offset| 0) 
 (* init_f_~i~2.offset 0) 
 (* |init_f_#t~malloc0.base| 0) 
 (* init_f_~j~2.base 0) (* |init_f_#in~l| 0) 
 (* |init_f_#t~malloc3.offset| 0) 
 (* |init_f_#t~malloc3.base| 0) 
 (* init_f_~k 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_f_#t~malloc2.offset| 0) 
 (* init_f_~l 0) (* |init_f_#t~malloc2.base| 0) 
 (* |init_f_#in~k| 0) (* init_f_~k_ref~2.offset 0)
 (* init_f_~l_ref~2.offset 0) 
 (* init_f_~j~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_f_#t~malloc1.base| 0) 
 (* |init_f_#t~malloc1.offset| 0) 
 (* init_f_~i~2.base 0) (* |init_#NULL.base| 0) 0) 0)))
 (or
 (and
 (= |honda_(select #length f_~j~2.base)|
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|))
 (= |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|))
 (= |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|))
 (= |honda_(select old(#length) f_~i~2.base)|
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= honda_f_~i~2.offset (+ honda_f_~i~2.offset ray_f_~i~2.offset))
 (= honda_f_~j~2.base (+ honda_f_~j~2.base ray_f_~j~2.base))
 (= |honda_(ite (select #valid f_~i~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~k (+ honda_f_~k ray_f_~k))
 (= honda_f_~l (+ honda_f_~l ray_f_~l))
 (= |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|))
 (= |honda_(select old(#length) f_~l_ref~2.base)|
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|))
 (= |honda_(select #length f_~i~2.base)|
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|))
 (= |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|))
 (= honda_f_~j~2.offset (+ honda_f_~j~2.offset ray_f_~j~2.offset))
 (= |honda_(select #length f_~l_ref~2.base)|
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|))
 (= |honda_(select #length f_~k_ref~2.base)|
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_f_~k_ref~2.base (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base))
 (= honda_f_~l_ref~2.base (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base))
 (= |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_f_#in~l| (+ |honda_f_#in~l| |ray_f_#in~l|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) f_~j~2.base)|
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= |honda_(select old(#length) f_~k_ref~2.base)|
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_f_#in~k| (+ |honda_f_#in~k| |ray_f_#in~k|))
 (= honda_f_~k_ref~2.offset
 (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset))
 (= honda_f_~l_ref~2.offset
 (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset))
 (=
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~i~2.base (+ honda_f_~i~2.base ray_f_~i~2.base))
 (= |honda_(ite (select #valid f_~j~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 1)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) (- 1))
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 
 (- 1)) (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6158 2) (* aux_6159 1) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6158 (- 2)) (* aux_6159 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6159 1) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) (- 1))
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6159 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) (- 1))
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) (- 1))
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 1)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 1)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) (- 1))
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 1)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) (- 1))
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 1)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 1)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 1)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (= |ray_(select #length f_~j~2.base)|
 (* |ray_(select #length f_~j~2.base)| lambda))
 (= |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda))
 (= |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) f_~i~2.base)|
 (* |ray_(select old(#length) f_~i~2.base)| lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= ray_f_~i~2.offset (* ray_f_~i~2.offset lambda))
 (= ray_f_~j~2.base (* ray_f_~j~2.base lambda))
 (= |ray_(ite (select #valid f_~i~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~k (* ray_f_~k lambda)) 
 (= ray_f_~l (* ray_f_~l lambda))
 (= |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) f_~l_ref~2.base)|
 (* |ray_(select old(#length) f_~l_ref~2.base)| lambda))
 (= |ray_(select #length f_~i~2.base)|
 (* |ray_(select #length f_~i~2.base)| lambda))
 (= |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda))
 (= ray_f_~j~2.offset (* ray_f_~j~2.offset lambda))
 (= |ray_(select #length f_~l_ref~2.base)|
 (* |ray_(select #length f_~l_ref~2.base)| lambda))
 (= |ray_(select #length f_~k_ref~2.base)|
 (* |ray_(select #length f_~k_ref~2.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda)) (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_f_~k_ref~2.base (* ray_f_~k_ref~2.base lambda))
 (= ray_f_~l_ref~2.base (* ray_f_~l_ref~2.base lambda))
 (= |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda)) (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_f_#in~l| (* |ray_f_#in~l| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) f_~j~2.base)|
 (* |ray_(select old(#length) f_~j~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= |ray_(select old(#length) f_~k_ref~2.base)|
 (* |ray_(select old(#length) f_~k_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_f_#in~k| (* |ray_f_#in~k| lambda))
 (= ray_f_~k_ref~2.offset (* ray_f_~k_ref~2.offset lambda))
 (= ray_f_~l_ref~2.offset (* ray_f_~l_ref~2.offset lambda))
 (=
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~i~2.base (* ray_f_~i~2.base lambda))
 (= |ray_(ite (select #valid f_~j~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 1)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) (- 1))
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 (- 1)) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 (- 1)) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6164 2) 
 (* aux_6165 1)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6164 (- 2)) 
 (* aux_6165 (- 1))) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6165 1)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 1)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) (- 1))
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 (- 1)) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6165 (- 1))) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) (- 1))
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) (- 1)) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 1)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) (- 1)) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 1) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) (- 1)) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 1)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 1) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 1) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length f_~j~2.base)|
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|))
 (= |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|))
 (= |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|))
 (= |honda_(select old(#length) f_~i~2.base)|
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= honda_f_~i~2.offset (+ honda_f_~i~2.offset ray_f_~i~2.offset))
 (= honda_f_~j~2.base (+ honda_f_~j~2.base ray_f_~j~2.base))
 (= |honda_(ite (select #valid f_~i~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~k (+ honda_f_~k ray_f_~k))
 (= honda_f_~l (+ honda_f_~l ray_f_~l))
 (= |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|))
 (= |honda_(select old(#length) f_~l_ref~2.base)|
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|))
 (= |honda_(select #length f_~i~2.base)|
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|))
 (= |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|))
 (= honda_f_~j~2.offset (+ honda_f_~j~2.offset ray_f_~j~2.offset))
 (= |honda_(select #length f_~l_ref~2.base)|
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|))
 (= |honda_(select #length f_~k_ref~2.base)|
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_f_~k_ref~2.base (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base))
 (= honda_f_~l_ref~2.base (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base))
 (= |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_f_#in~l| (+ |honda_f_#in~l| |ray_f_#in~l|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) f_~j~2.base)|
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= |honda_(select old(#length) f_~k_ref~2.base)|
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_f_#in~k| (+ |honda_f_#in~k| |ray_f_#in~k|))
 (= honda_f_~k_ref~2.offset
 (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset))
 (= honda_f_~l_ref~2.offset
 (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset))
 (=
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~i~2.base (+ honda_f_~i~2.base ray_f_~i~2.base))
 (= |honda_(ite (select #valid f_~j~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 1)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) (- 1))
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 
 (- 1)) (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6170 2) (* aux_6171 1) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6170 (- 2)) (* aux_6171 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6171 1) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) (- 1))
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6171 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) (- 1))
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) (- 1))
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 1)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 1)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) (- 1))
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 1)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 1)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 1)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 1)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (= |ray_(select #length f_~j~2.base)|
 (* |ray_(select #length f_~j~2.base)| lambda))
 (= |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda))
 (= |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) f_~i~2.base)|
 (* |ray_(select old(#length) f_~i~2.base)| lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= ray_f_~i~2.offset (* ray_f_~i~2.offset lambda))
 (= ray_f_~j~2.base (* ray_f_~j~2.base lambda))
 (= |ray_(ite (select #valid f_~i~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~k (* ray_f_~k lambda)) 
 (= ray_f_~l (* ray_f_~l lambda))
 (= |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) f_~l_ref~2.base)|
 (* |ray_(select old(#length) f_~l_ref~2.base)| lambda))
 (= |ray_(select #length f_~i~2.base)|
 (* |ray_(select #length f_~i~2.base)| lambda))
 (= |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda))
 (= ray_f_~j~2.offset (* ray_f_~j~2.offset lambda))
 (= |ray_(select #length f_~l_ref~2.base)|
 (* |ray_(select #length f_~l_ref~2.base)| lambda))
 (= |ray_(select #length f_~k_ref~2.base)|
 (* |ray_(select #length f_~k_ref~2.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda)) (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_f_~k_ref~2.base (* ray_f_~k_ref~2.base lambda))
 (= ray_f_~l_ref~2.base (* ray_f_~l_ref~2.base lambda))
 (= |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda)) (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_f_#in~l| (* |ray_f_#in~l| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) f_~j~2.base)|
 (* |ray_(select old(#length) f_~j~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= |ray_(select old(#length) f_~k_ref~2.base)|
 (* |ray_(select old(#length) f_~k_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_f_#in~k| (* |ray_f_#in~k| lambda))
 (= ray_f_~k_ref~2.offset (* ray_f_~k_ref~2.offset lambda))
 (= ray_f_~l_ref~2.offset (* ray_f_~l_ref~2.offset lambda))
 (=
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~i~2.base (* ray_f_~i~2.base lambda))
 (= |ray_(ite (select #valid f_~j~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 1)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) (- 1))
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 (- 1)) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 (- 1)) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6176 2) 
 (* aux_6177 1)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6176 (- 2)) 
 (* aux_6177 (- 1))) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6177 1)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 1)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) (- 1))
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 (- 1)) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6177 (- 1))) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) (- 1))
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) (- 1)) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 1)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) (- 1)) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 1)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 1) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 1) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 1) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length f_~j~2.base)|
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|))
 (= |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|))
 (= |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|))
 (= |honda_(select old(#length) f_~i~2.base)|
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= honda_f_~i~2.offset (+ honda_f_~i~2.offset ray_f_~i~2.offset))
 (= honda_f_~j~2.base (+ honda_f_~j~2.base ray_f_~j~2.base))
 (= |honda_(ite (select #valid f_~i~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~k (+ honda_f_~k ray_f_~k))
 (= honda_f_~l (+ honda_f_~l ray_f_~l))
 (= |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|))
 (= |honda_(select old(#length) f_~l_ref~2.base)|
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|))
 (= |honda_(select #length f_~i~2.base)|
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|))
 (= |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|))
 (= honda_f_~j~2.offset (+ honda_f_~j~2.offset ray_f_~j~2.offset))
 (= |honda_(select #length f_~l_ref~2.base)|
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|))
 (= |honda_(select #length f_~k_ref~2.base)|
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_f_~k_ref~2.base (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base))
 (= honda_f_~l_ref~2.base (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base))
 (= |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_f_#in~l| (+ |honda_f_#in~l| |ray_f_#in~l|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) f_~j~2.base)|
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= |honda_(select old(#length) f_~k_ref~2.base)|
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_f_#in~k| (+ |honda_f_#in~k| |ray_f_#in~k|))
 (= honda_f_~k_ref~2.offset
 (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset))
 (= honda_f_~l_ref~2.offset
 (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset))
 (=
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~i~2.base (+ honda_f_~i~2.base ray_f_~i~2.base))
 (= |honda_(ite (select #valid f_~j~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 1)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) (- 1))
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 
 (- 1)) (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6182 2) (* aux_6183 1) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6182 (- 2)) (* aux_6183 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6183 1) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) (- 1))
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6183 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) (- 1))
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 1)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 1)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) (- 1))
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 1)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 1)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) (- 1))
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) (- 1))
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 1)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 1)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (= |ray_(select #length f_~j~2.base)|
 (* |ray_(select #length f_~j~2.base)| lambda))
 (= |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda))
 (= |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) f_~i~2.base)|
 (* |ray_(select old(#length) f_~i~2.base)| lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= ray_f_~i~2.offset (* ray_f_~i~2.offset lambda))
 (= ray_f_~j~2.base (* ray_f_~j~2.base lambda))
 (= |ray_(ite (select #valid f_~i~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~k (* ray_f_~k lambda)) 
 (= ray_f_~l (* ray_f_~l lambda))
 (= |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) f_~l_ref~2.base)|
 (* |ray_(select old(#length) f_~l_ref~2.base)| lambda))
 (= |ray_(select #length f_~i~2.base)|
 (* |ray_(select #length f_~i~2.base)| lambda))
 (= |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda))
 (= ray_f_~j~2.offset (* ray_f_~j~2.offset lambda))
 (= |ray_(select #length f_~l_ref~2.base)|
 (* |ray_(select #length f_~l_ref~2.base)| lambda))
 (= |ray_(select #length f_~k_ref~2.base)|
 (* |ray_(select #length f_~k_ref~2.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda)) (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_f_~k_ref~2.base (* ray_f_~k_ref~2.base lambda))
 (= ray_f_~l_ref~2.base (* ray_f_~l_ref~2.base lambda))
 (= |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda)) (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_f_#in~l| (* |ray_f_#in~l| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) f_~j~2.base)|
 (* |ray_(select old(#length) f_~j~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= |ray_(select old(#length) f_~k_ref~2.base)|
 (* |ray_(select old(#length) f_~k_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_f_#in~k| (* |ray_f_#in~k| lambda))
 (= ray_f_~k_ref~2.offset (* ray_f_~k_ref~2.offset lambda))
 (= ray_f_~l_ref~2.offset (* ray_f_~l_ref~2.offset lambda))
 (=
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~i~2.base (* ray_f_~i~2.base lambda))
 (= |ray_(ite (select #valid f_~j~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 1)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) (- 1))
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 (- 1)) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 (- 1)) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6188 2) 
 (* aux_6189 1)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6188 (- 2)) 
 (* aux_6189 (- 1))) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6189 1)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 1)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) (- 1))
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 (- 1)) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6189 (- 1))) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) (- 1)) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 1)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) (- 1)) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 1)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 1) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) (- 1))
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) (- 1)) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 1) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 1) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length f_~j~2.base)|
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|))
 (= |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|))
 (= |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|))
 (= |honda_(select old(#length) f_~i~2.base)|
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= honda_f_~i~2.offset (+ honda_f_~i~2.offset ray_f_~i~2.offset))
 (= honda_f_~j~2.base (+ honda_f_~j~2.base ray_f_~j~2.base))
 (= |honda_(ite (select #valid f_~i~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~k (+ honda_f_~k ray_f_~k))
 (= honda_f_~l (+ honda_f_~l ray_f_~l))
 (= |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|))
 (= |honda_(select old(#length) f_~l_ref~2.base)|
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|))
 (= |honda_(select #length f_~i~2.base)|
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|))
 (= |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|))
 (= honda_f_~j~2.offset (+ honda_f_~j~2.offset ray_f_~j~2.offset))
 (= |honda_(select #length f_~l_ref~2.base)|
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|))
 (= |honda_(select #length f_~k_ref~2.base)|
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_f_~k_ref~2.base (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base))
 (= honda_f_~l_ref~2.base (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base))
 (= |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_f_#in~l| (+ |honda_f_#in~l| |ray_f_#in~l|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) f_~j~2.base)|
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= |honda_(select old(#length) f_~k_ref~2.base)|
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_f_#in~k| (+ |honda_f_#in~k| |ray_f_#in~k|))
 (= honda_f_~k_ref~2.offset
 (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset))
 (= honda_f_~l_ref~2.offset
 (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset))
 (=
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~i~2.base (+ honda_f_~i~2.base ray_f_~i~2.base))
 (= |honda_(ite (select #valid f_~j~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 1)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) (- 1))
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 
 (- 1)) (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6194 2) (* aux_6195 1) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6194 (- 2)) (* aux_6195 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6195 1) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) (- 1))
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6195 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) (- 1))
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 1)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 1)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) (- 1))
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 1)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 1)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 1)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) (- 1))
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 1)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 1)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (= |ray_(select #length f_~j~2.base)|
 (* |ray_(select #length f_~j~2.base)| lambda))
 (= |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda))
 (= |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) f_~i~2.base)|
 (* |ray_(select old(#length) f_~i~2.base)| lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= ray_f_~i~2.offset (* ray_f_~i~2.offset lambda))
 (= ray_f_~j~2.base (* ray_f_~j~2.base lambda))
 (= |ray_(ite (select #valid f_~i~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~k (* ray_f_~k lambda)) 
 (= ray_f_~l (* ray_f_~l lambda))
 (= |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) f_~l_ref~2.base)|
 (* |ray_(select old(#length) f_~l_ref~2.base)| lambda))
 (= |ray_(select #length f_~i~2.base)|
 (* |ray_(select #length f_~i~2.base)| lambda))
 (= |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda))
 (= ray_f_~j~2.offset (* ray_f_~j~2.offset lambda))
 (= |ray_(select #length f_~l_ref~2.base)|
 (* |ray_(select #length f_~l_ref~2.base)| lambda))
 (= |ray_(select #length f_~k_ref~2.base)|
 (* |ray_(select #length f_~k_ref~2.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda)) (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_f_~k_ref~2.base (* ray_f_~k_ref~2.base lambda))
 (= ray_f_~l_ref~2.base (* ray_f_~l_ref~2.base lambda))
 (= |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda)) (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_f_#in~l| (* |ray_f_#in~l| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) f_~j~2.base)|
 (* |ray_(select old(#length) f_~j~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= |ray_(select old(#length) f_~k_ref~2.base)|
 (* |ray_(select old(#length) f_~k_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_f_#in~k| (* |ray_f_#in~k| lambda))
 (= ray_f_~k_ref~2.offset (* ray_f_~k_ref~2.offset lambda))
 (= ray_f_~l_ref~2.offset (* ray_f_~l_ref~2.offset lambda))
 (=
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~i~2.base (* ray_f_~i~2.base lambda))
 (= |ray_(ite (select #valid f_~j~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 1)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) (- 1))
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 (- 1)) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 (- 1)) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6200 2) 
 (* aux_6201 1)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6200 (- 2)) 
 (* aux_6201 (- 1))) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6201 1)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 1)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) (- 1))
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 (- 1)) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6201 (- 1))) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) (- 1)) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 1)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) (- 1)) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 1)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 1) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 1) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) (- 1))
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 1) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 1) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length f_~j~2.base)|
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|))
 (= |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|))
 (= |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|))
 (= |honda_(select old(#length) f_~i~2.base)|
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= honda_f_~i~2.offset (+ honda_f_~i~2.offset ray_f_~i~2.offset))
 (= honda_f_~j~2.base (+ honda_f_~j~2.base ray_f_~j~2.base))
 (= |honda_(ite (select #valid f_~i~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~k (+ honda_f_~k ray_f_~k))
 (= honda_f_~l (+ honda_f_~l ray_f_~l))
 (= |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|))
 (= |honda_(select old(#length) f_~l_ref~2.base)|
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|))
 (= |honda_(select #length f_~i~2.base)|
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|))
 (= |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|))
 (= honda_f_~j~2.offset (+ honda_f_~j~2.offset ray_f_~j~2.offset))
 (= |honda_(select #length f_~l_ref~2.base)|
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|))
 (= |honda_(select #length f_~k_ref~2.base)|
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_f_~k_ref~2.base (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base))
 (= honda_f_~l_ref~2.base (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base))
 (= |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_f_#in~l| (+ |honda_f_#in~l| |ray_f_#in~l|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) f_~j~2.base)|
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= |honda_(select old(#length) f_~k_ref~2.base)|
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_f_#in~k| (+ |honda_f_#in~k| |ray_f_#in~k|))
 (= honda_f_~k_ref~2.offset
 (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset))
 (= honda_f_~l_ref~2.offset
 (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset))
 (=
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~i~2.base (+ honda_f_~i~2.base ray_f_~i~2.base))
 (= |honda_(ite (select #valid f_~j~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 1)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) (- 1))
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 
 (- 1)) (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6206 2) (* aux_6207 1) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6206 (- 2)) (* aux_6207 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6207 1) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) (- 1))
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6207 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) (- 1))
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 1)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 1)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) (- 1))
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 1)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) (- 1))
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 1)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 1)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 1)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 1)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (= |ray_(select #length f_~j~2.base)|
 (* |ray_(select #length f_~j~2.base)| lambda))
 (= |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda))
 (= |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) f_~i~2.base)|
 (* |ray_(select old(#length) f_~i~2.base)| lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= ray_f_~i~2.offset (* ray_f_~i~2.offset lambda))
 (= ray_f_~j~2.base (* ray_f_~j~2.base lambda))
 (= |ray_(ite (select #valid f_~i~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~k (* ray_f_~k lambda)) 
 (= ray_f_~l (* ray_f_~l lambda))
 (= |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) f_~l_ref~2.base)|
 (* |ray_(select old(#length) f_~l_ref~2.base)| lambda))
 (= |ray_(select #length f_~i~2.base)|
 (* |ray_(select #length f_~i~2.base)| lambda))
 (= |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda))
 (= ray_f_~j~2.offset (* ray_f_~j~2.offset lambda))
 (= |ray_(select #length f_~l_ref~2.base)|
 (* |ray_(select #length f_~l_ref~2.base)| lambda))
 (= |ray_(select #length f_~k_ref~2.base)|
 (* |ray_(select #length f_~k_ref~2.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda)) (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_f_~k_ref~2.base (* ray_f_~k_ref~2.base lambda))
 (= ray_f_~l_ref~2.base (* ray_f_~l_ref~2.base lambda))
 (= |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda)) (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_f_#in~l| (* |ray_f_#in~l| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) f_~j~2.base)|
 (* |ray_(select old(#length) f_~j~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= |ray_(select old(#length) f_~k_ref~2.base)|
 (* |ray_(select old(#length) f_~k_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_f_#in~k| (* |ray_f_#in~k| lambda))
 (= ray_f_~k_ref~2.offset (* ray_f_~k_ref~2.offset lambda))
 (= ray_f_~l_ref~2.offset (* ray_f_~l_ref~2.offset lambda))
 (=
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~i~2.base (* ray_f_~i~2.base lambda))
 (= |ray_(ite (select #valid f_~j~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 1)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) (- 1))
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 (- 1)) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 (- 1)) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6212 2) 
 (* aux_6213 1)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6212 (- 2)) 
 (* aux_6213 (- 1))) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6213 1)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 1)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) (- 1))
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 (- 1)) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6213 (- 1))) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) (- 1)) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 1)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) (- 1)) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 1) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) (- 1)) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 1)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 1) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 1) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 1) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length f_~j~2.base)|
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|))
 (= |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|))
 (= |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|))
 (= |honda_(select old(#length) f_~i~2.base)|
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|))
 (= |honda_f_#t~malloc0.offset|
 (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|))
 (= honda_f_~i~2.offset (+ honda_f_~i~2.offset ray_f_~i~2.offset))
 (= honda_f_~j~2.base (+ honda_f_~j~2.base ray_f_~j~2.base))
 (= |honda_(ite (select #valid f_~i~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|))
 (= |honda_f_#t~malloc3.offset|
 (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|))
 (= honda_f_~k (+ honda_f_~k ray_f_~k))
 (= honda_f_~l (+ honda_f_~l ray_f_~l))
 (= |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|))
 (= |honda_(select old(#length) f_~l_ref~2.base)|
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|))
 (= |honda_(select #length f_~i~2.base)|
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|))
 (= |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|))
 (= honda_f_~j~2.offset (+ honda_f_~j~2.offset ray_f_~j~2.offset))
 (= |honda_(select #length f_~l_ref~2.base)|
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|))
 (= |honda_(select #length f_~k_ref~2.base)|
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_f_#t~malloc1.offset|
 (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|))
 (= |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_f_~k_ref~2.base (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base))
 (= honda_f_~l_ref~2.base (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base))
 (= |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|))
 (= |honda_f_#t~malloc0.base|
 (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|))
 (= |honda_f_#in~l| (+ |honda_f_#in~l| |ray_f_#in~l|))
 (= |honda_f_#t~malloc3.base|
 (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) f_~j~2.base)|
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|))
 (= |honda_f_#t~malloc2.offset|
 (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|))
 (= |honda_(select old(#length) f_~k_ref~2.base)|
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|))
 (= |honda_f_#t~malloc2.base|
 (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|))
 (= |honda_f_#in~k| (+ |honda_f_#in~k| |ray_f_#in~k|))
 (= honda_f_~k_ref~2.offset
 (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset))
 (= honda_f_~l_ref~2.offset
 (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset))
 (=
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|))
 (= |honda_f_#t~malloc1.base|
 (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|))
 (= honda_f_~i~2.base (+ honda_f_~i~2.base ray_f_~i~2.base))
 (= |honda_(ite (select #valid f_~j~2.base) 1 0)|
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|))
 (= |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 1)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) (- 1))
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 
 (- 1)) (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6218 2) (* aux_6219 1) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6218 (- 2)) (* aux_6219 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6219 1) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|)
 (- 1))
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 1) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) (- 1))
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (* aux_6219 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 1)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) (- 1))
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 1)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 1)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 1)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) (- 1))
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 1)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 1)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) (- 1))
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) (- 1))
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 1)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 1)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) (- 1))
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 1)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length f_~j~2.base)| |ray_(select #length f_~j~2.base)|)
 0)
 (*
 (+ |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~j~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~i~2.base)|
 |ray_(select old(#length) f_~i~2.base)|) 0)
 (* (+ |honda_f_#t~malloc0.offset| |ray_f_#t~malloc0.offset|) 0)
 (* (+ honda_f_~i~2.offset ray_f_~i~2.offset) 0)
 (* (+ honda_f_~j~2.base ray_f_~j~2.base) 0)
 (* (+ |honda_f_#t~mem13| |ray_f_#t~mem13|) 0)
 (*
 (+ |honda_(ite (select #valid f_~i~2.base) 1 0)|
 |ray_(ite (select #valid f_~i~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc3.offset| |ray_f_#t~malloc3.offset|) 0)
 (* (+ honda_f_~k ray_f_~k) 0) 
 (* (+ honda_f_~l ray_f_~l) 0)
 (*
 (+ |honda_(ite (select #valid f_~k_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) f_~l_ref~2.base)|
 |ray_(select old(#length) f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)|) 0)
 (*
 (+ |honda_(select #length f_~i~2.base)| |ray_(select #length f_~i~2.base)|)
 0)
 (*
 (+ |honda_(ite (select #valid f_~l_ref~2.base) 1 0)|
 |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|) 0)
 (* (+ honda_f_~j~2.offset ray_f_~j~2.offset) 0)
 (*
 (+ |honda_(select #length f_~l_ref~2.base)|
 |ray_(select #length f_~l_ref~2.base)|) 0)
 (*
 (+ |honda_(select #length f_~k_ref~2.base)|
 |ray_(select #length f_~k_ref~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_f_#t~malloc1.offset| |ray_f_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_f_~k_ref~2.base ray_f_~k_ref~2.base) 0)
 (* (+ honda_f_~l_ref~2.base ray_f_~l_ref~2.base) 0)
 (*
 (+ |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|
 |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)|) 1)
 (* (+ |honda_f_#t~post15| |ray_f_#t~post15|) 0)
 (*
 (+ |honda_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|) 0)
 (* (+ |honda_f_#t~malloc0.base| |ray_f_#t~malloc0.base|) 0)
 (* (+ |honda_f_#in~l| |ray_f_#in~l|) 0)
 (* (+ |honda_f_#t~malloc3.base| |ray_f_#t~malloc3.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) f_~j~2.base)|
 |ray_(select old(#length) f_~j~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.offset| |ray_f_#t~malloc2.offset|) 0)
 (*
 (+ |honda_(select old(#length) f_~k_ref~2.base)|
 |ray_(select old(#length) f_~k_ref~2.base)|) 0)
 (* (+ |honda_f_#t~malloc2.base| |ray_f_#t~malloc2.base|) 0)
 (* (+ |honda_f_#in~k| |ray_f_#in~k|) 0)
 (* (+ honda_f_~k_ref~2.offset ray_f_~k_ref~2.offset) 0)
 (* (+ honda_f_~l_ref~2.offset ray_f_~l_ref~2.offset) 0)
 (* (+ |honda_f_#t~mem14| |ray_f_#t~mem14|) 0)
 (* (+ |honda_f_#t~mem16| |ray_f_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|) 0)
 (* (+ |honda_f_#t~malloc1.base| |ray_f_#t~malloc1.base|) 0)
 (* (+ |honda_f_#t~mem9| |ray_f_#t~mem9|) 0)
 (* (+ honda_f_~i~2.base ray_f_~i~2.base) 0)
 (*
 (+ |honda_(ite (select #valid f_~j~2.base) 1 0)|
 |ray_(ite (select #valid f_~j~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|)
 0) (* (+ |honda_f_#t~mem8| |ray_f_#t~mem8|) 0)
 (*
 (+ |honda_(ite (select old(#valid) f_~i~2.base) 1 0)|
 |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|) 0)
 (* |honda_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 0) (* |honda_f_#t~mem13| 0)
 (* |honda_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |honda_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |honda_f_#t~post15| 0) 
 (* |honda_f_#t~mem14| 0) 
 (* |honda_f_#t~mem16| 0) 
 (* |honda_f_#t~mem9| 0) (* |honda_f_#t~mem8| 0) 
 (- 1)) 0)
 (= |ray_(select #length f_~j~2.base)|
 (* |ray_(select #length f_~j~2.base)| lambda))
 (= |ray_(ite (select old(#valid) f_~j~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda))
 (= |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) f_~i~2.base)|
 (* |ray_(select old(#length) f_~i~2.base)| lambda))
 (= |ray_f_#t~malloc0.offset| (* |ray_f_#t~malloc0.offset| lambda))
 (= ray_f_~i~2.offset (* ray_f_~i~2.offset lambda))
 (= ray_f_~j~2.base (* ray_f_~j~2.base lambda))
 (= |ray_(ite (select #valid f_~i~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc3.offset| (* |ray_f_#t~malloc3.offset| lambda))
 (= ray_f_~k (* ray_f_~k lambda)) 
 (= ray_f_~l (* ray_f_~l lambda))
 (= |ray_(ite (select #valid f_~k_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) f_~l_ref~2.base)|
 (* |ray_(select old(#length) f_~l_ref~2.base)| lambda))
 (= |ray_(select #length f_~i~2.base)|
 (* |ray_(select #length f_~i~2.base)| lambda))
 (= |ray_(ite (select #valid f_~l_ref~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda))
 (= ray_f_~j~2.offset (* ray_f_~j~2.offset lambda))
 (= |ray_(select #length f_~l_ref~2.base)|
 (* |ray_(select #length f_~l_ref~2.base)| lambda))
 (= |ray_(select #length f_~k_ref~2.base)|
 (* |ray_(select #length f_~k_ref~2.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_f_#t~malloc1.offset| (* |ray_f_#t~malloc1.offset| lambda))
 (= |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda)) (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_f_~k_ref~2.base (* ray_f_~k_ref~2.base lambda))
 (= ray_f_~l_ref~2.base (* ray_f_~l_ref~2.base lambda))
 (= |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda)) (= |ray_f_#t~malloc0.base| (* |ray_f_#t~malloc0.base| lambda))
 (= |ray_f_#in~l| (* |ray_f_#in~l| lambda))
 (= |ray_f_#t~malloc3.base| (* |ray_f_#t~malloc3.base| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) f_~j~2.base)|
 (* |ray_(select old(#length) f_~j~2.base)| lambda))
 (= |ray_f_#t~malloc2.offset| (* |ray_f_#t~malloc2.offset| lambda))
 (= |ray_(select old(#length) f_~k_ref~2.base)|
 (* |ray_(select old(#length) f_~k_ref~2.base)| lambda))
 (= |ray_f_#t~malloc2.base| (* |ray_f_#t~malloc2.base| lambda))
 (= |ray_f_#in~k| (* |ray_f_#in~k| lambda))
 (= ray_f_~k_ref~2.offset (* ray_f_~k_ref~2.offset lambda))
 (= ray_f_~l_ref~2.offset (* ray_f_~l_ref~2.offset lambda))
 (=
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda))
 (= |ray_f_#t~malloc1.base| (* |ray_f_#t~malloc1.base| lambda))
 (= ray_f_~i~2.base (* ray_f_~i~2.base lambda))
 (= |ray_(ite (select #valid f_~j~2.base) 1 0)|
 (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) f_~i~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 1)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) (- 1))
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 (- 1)) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 1)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 (- 1)) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6224 2) 
 (* aux_6225 1)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6224 (- 2)) 
 (* aux_6225 (- 1))) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6225 1)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 1)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) (- 1))
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 (- 1)) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 1)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0) (* aux_6225 (- 1))) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 1)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) (- 1)) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 1)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 1) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 (- 1)) (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 1)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) (- 1)) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 1)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 1) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) (- 1)) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 1)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 1) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) (- 1))
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 1) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 0) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| (- 1))
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| 0)
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length f_~j~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_(ite (select old(#valid) f_~j~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~i~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc0.offset| lambda) 0)
 (* (* ray_f_~i~2.offset lambda) 0) 
 (* (* ray_f_~j~2.base lambda) 0) 
 (* (* |ray_f_#t~mem13| lambda) 0)
 (* (* |ray_(ite (select #valid f_~i~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc3.offset| lambda) 0) 
 (* (* ray_f_~k lambda) 0) 
 (* (* ray_f_~l lambda) 0)
 (* (* |ray_(ite (select #valid f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| lambda)
 0) (* (* |ray_(select #length f_~i~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid f_~l_ref~2.base) 1 0)| lambda) 0)
 (* (* ray_f_~j~2.offset lambda) 0)
 (* (* |ray_(select #length f_~l_ref~2.base)| lambda) 0)
 (* (* |ray_(select #length f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_f_#t~malloc1.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~j~2.base) f_~j~2.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* (* ray_f_~k_ref~2.base lambda) 0) 
 (* (* ray_f_~l_ref~2.base lambda) 0)
 (* (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| lambda)
 1) (* (* |ray_f_#t~post15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) f_~i~2.base) f_~i~2.offset)|
 lambda) 0) (* (* |ray_f_#t~malloc0.base| lambda) 0)
 (* (* |ray_f_#in~l| lambda) 0) 
 (* (* |ray_f_#t~malloc3.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) f_~j~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.offset| lambda) 0)
 (* (* |ray_(select old(#length) f_~k_ref~2.base)| lambda) 0)
 (* (* |ray_f_#t~malloc2.base| lambda) 0) 
 (* (* |ray_f_#in~k| lambda) 0) 
 (* (* ray_f_~k_ref~2.offset lambda) 0)
 (* (* ray_f_~l_ref~2.offset lambda) 0) 
 (* (* |ray_f_#t~mem14| lambda) 0) 
 (* (* |ray_f_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~l_ref~2.base) f_~l_ref~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~k_ref~2.base) 1 0)| lambda) 0)
 (* (* |ray_f_#t~malloc1.base| lambda) 0) 
 (* (* |ray_f_#t~mem9| lambda) 0) 
 (* (* ray_f_~i~2.base lambda) 0)
 (* (* |ray_(ite (select #valid f_~j~2.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) f_~k_ref~2.base) f_~k_ref~2.offset)|
 lambda) 0) (* (* |ray_f_#t~mem8| lambda) 0)
 (* (* |ray_(ite (select old(#valid) f_~i~2.base) 1 0)| lambda) 0)
 (* |ray_(select (select #memory_int f_~k_ref~2.base) f_~k_ref~2.offset)| 0)
 (* |ray_f_#t~mem13| 0)
 (* |ray_(select (select #memory_int f_~i~2.base) f_~i~2.offset)| 0)
 (* |ray_(select (select #memory_int f_~j~2.base) f_~j~2.offset)| (- 1))
 (* |ray_f_#t~post15| 0) (* |ray_f_#t~mem14| 0) 
 (* |ray_f_#t~mem16| 0) (* |ray_f_#t~mem9| 0) 
 (* |ray_f_#t~mem8| 0)) 0) 
 (= lambda lambda))) (>= lambda 0)))
(check-sat)
(exit)

